"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var _metadata_keys_1 = require("./_metadata-keys");
var unused_1 = require("../unused");
function GetTestCases(caseArguments) {
    if (null === caseArguments || undefined === caseArguments) {
        return [];
    }
    if (caseArguments instanceof Function) {
        return GetTestCases(caseArguments());
    }
    if (caseArguments instanceof Array) {
        return caseArguments.slice();
    }
    else {
        return Array.from(caseArguments);
    }
}
function TestCases(caseArguments) {
    return function (target, propertyKey, descriptor) {
        unused_1.Unused(descriptor);
        // check if this has been registered as a test already
        var tests = Reflect.getMetadata(_metadata_keys_1.TESTS, target);
        if (!tests) {
            // if there are no tests registered yet then register it
            tests = [{
                    key: propertyKey
                }];
            Reflect.defineMetadata(_metadata_keys_1.TESTS, tests, target);
        }
        else if (tests.filter(function (test) { return test.key === propertyKey; }).length === 0) {
            // otherwise add it to the register
            tests.push({
                key: propertyKey
            });
            Reflect.defineMetadata(_metadata_keys_1.TESTS, tests, target);
        }
        var testCases = GetTestCases(caseArguments).reduce(function (acc, val) {
            // add the test case to the list
            return acc.concat([{
                    caseArguments: val
                }]);
        }, Reflect.getMetadata(_metadata_keys_1.TEST_CASES, target, propertyKey) || []);
        // update the list of test cases
        Reflect.defineMetadata(_metadata_keys_1.TEST_CASES, testCases, target, propertyKey);
    };
}
exports.TestCases = TestCases;
//# sourceMappingURL=test-cases-decorator.js.map